// Obliczanie calki wielomianu metoda Simpsona

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <math.h>

// Maksymalna liczba przedzialow = 3000
// Maksymalna liczba wyrazow wielomianu = 100
double x[3000],y[3000];
double w[100];
int p[100];
int l_wyrazow=0;

// Funkcja wypisujaca na ekranie wielomian na podstawie tablic w i p
void wypisz_wielomian()
{
	int i;
	for (i=0; i<l_wyrazow; i++)
	{
		printf("%.10g",w[i]);
		switch (p[i])
		{
			case 0:
				break;
			case 1:
				printf("x");
				break;
			default:
				printf("x^%d",p[i]);
		}
		// Czy to nie jest ostatni wyraz?
		if ((i+1)<l_wyrazow)
		{
			if (w[i+1]>0)
				printf("+");
		}
	}
	printf("\n");
}


void main()
{

	double skok,wynik=0,parzyste=0,nieparzyste=0;
	float gr_dolna,gr_gorna;
	char wspolczynnik[255];
	int wykladnik;
	int l_przedzialow,i,j;

	clrscr();

	printf("               Calkowanie numeryczne wielomianu metoda Simpsona\n\n");
	printf("Podaj kolejne wyrazy wielomianu:\n");
	printf("(0 - konczy wprowadzanie, c - usuwa ostatni wyraz wielomianu)\n");

	// Wprowadzenie wspolczynnikow i wykladnikow wielomianu
	do
	{
		do
		{
wprowadz:
			printf("Wspolczynnik: ");
			scanf("%s",wspolczynnik);
			fflush(stdin);
			if (atof(wspolczynnik)==0)
			{
				if (wspolczynnik[0]=='c')
				{
					if (l_wyrazow>0)
						l_wyrazow--;
					printf("Wielomian: ");
					wypisz_wielomian();
					goto wprowadz;
				}
				goto koniec;
			}
			printf("Wykladnik: ");
			scanf("%d",&wykladnik);
			if (wykladnik<0)
				printf("Wykladnik powinnien byc nieujemny!\n");
		}
		while (wykladnik<0);
		w[l_wyrazow] = atof(wspolczynnik);
		p[l_wyrazow] = wykladnik;
		l_wyrazow++;
		printf("Wielomian: ");
		wypisz_wielomian();
	}
	while (l_wyrazow<100);

koniec:

	printf("\n");

	// Wprowadzenie granic calkowania
	do
	{
		printf("Podaj dolna granice calkowania: ");
		scanf("%f",&gr_dolna);
		fflush(stdin);
		printf("Podaj gorna granice calkowania: ");
		scanf("%f",&gr_gorna);
		if (gr_dolna>=gr_gorna)
			printf("Granica gorna powinna byc wieksza od dolnej!\r\n");
	}
	while(gr_dolna>=gr_gorna);

	printf("\n");

	// Wprowadzenie liczby przedzialow calkowania
	do
	{
		printf("Podaj parzysta, dodatnia liczbe l_przedzialowow (maks. 3000): ");
		scanf("%d",&l_przedzialow);
		if (l_przedzialow<=0)
			printf("Liczba l_przedzialowow powinna byc wieksza od zera!\r\n");

		if (l_przedzialow>3000)
			printf("Podana liczba l_przedzialowow przekracza maksymalna!\r\n");

		if (l_przedzialow%2!=0)
			printf("Liczba l_przedzialowow powinna byc parzysta!\r\n");
	}
	while(l_przedzialow<=0 || l_przedzialow%2!=0 || l_przedzialow>3000);

	skok=(fabs(gr_dolna)+fabs(gr_gorna))/l_przedzialow;

	// Wyznaczenie kolejnych wartosci na osi x
	x[0]=gr_dolna;
	x[l_przedzialow]=gr_gorna;
	for(i=1;i<l_przedzialow;i++)
		x[i]=x[i-1]+skok;

	// Obliczenie wartosci wielomianu dla kolejnych x
	for(i=0;i<=l_przedzialow;i++)
	{
		y[i] = 0;
		for (j=0; j<l_wyrazow; j++)
		{
			y[i] = y[i] + w[j]*pow(x[i],(double)p[j]);
		}
	}
	// Obliczenie sumy rzednych nieparzystych
	for(i=1;i<=l_przedzialow-1;i+=2)
		nieparzyste=nieparzyste+y[i];

	// Obliczenie sumy rzednych parzystych
	for(i=2;i<=l_przedzialow-2;i+=2)
		parzyste=parzyste+y[i];

	wynik=((gr_gorna-gr_dolna)/(6*l_przedzialow/2))*(y[0]+y[l_przedzialow]+4*nieparzyste+2*parzyste);

	printf("\n");

	printf("Calka wielomianu: ");
	wypisz_wielomian();
	printf("w granicach [%.10g,%.10g] wynosi: %.10g\n\n",gr_dolna,gr_gorna,wynik);
	printf("Nacisnij dowolny klawisz...");

	getch();
}

